/**
 * Allows you to hoist methods, except those in an exclusion set from a source object into a destination object.
 * @returns {string[]} An array of names of methods that were hoisted.
 */
export declare function hoistMethods(destination: any, source: any, exclusions?: string[]): string[];
/**
 * Provides a method for convenience to unhoist hoisted methods.
 * @param {Object} source The source object upon which methods were hoisted.
 * @param {string[]} methodNames An array of method names to unhoist.
 */
export declare function unhoistMethods(source: Object, methodNames: string[]): void;
